%% optValueΪȫӦֵbestPΪȫӵλ
%% fTypeΪĿԺͣpTypeΪģͲ½õ
%% ------------------%%
function [optValue,bestP,endNFEs]=TAPSO(fType,pType,Max_NFEs,NP)
    addpath('../');
    
    [UB,LB,Dim] = Parameter(pType); % UBΪϽ磺1*DimLBΪ½磺1*Dim
    
    index = fType; % Ժ
    w = 0.7298; % wΪ
    p_c = 0.5; % 
    p_m = 0.02; % 
    t = 0; % 
    Ae = []; % Ae浵
    Ap = []; % Ap浵
    Ao = []; % Ao浵
    sizeAo = 0;
    M = ceil(NP/4); % AeAp浵Ĺģ
    Vmin = repmat(-0.2*(UB-LB),NP,1); % Сٶ
    Vmax = -Vmin; % ٶ
    X_Velocity = Vmin + rand(NP,Dim).*(Vmax-Vmin); % ӳʼٶ   NP*Dim
    X_Position = repmat(LB,NP,1) + rand(NP,Dim).* repmat((UB-LB),NP,1); % ӳʼλ   NP*Dim

    for i=1:NP
        fitnessX(i) = TestFunction(index,X_Position(i,:)); %  Xi
    end
    NFEs = NP;
    PBest_pos = X_Position; %¼ʷλãPBest_pos   NP*Dim
    PBest_fitness = fitnessX; %¼ʷӦֵPBest_fitness    1*NP
    [GBest_fitness,GBest_index] = min(fitnessX); %ȫӦֵGBest_fitness    1*1
    GBest_pos = X_Position(GBest_index,:); %¼ǰȫλ   1*Dim
    
    while NFEs < Max_NFEs
        t = t+1;
        
        lastGenFitnessX = fitnessX; %һӵӦֵlastGenFitnessX       NP*1
        lastGenX_Position = X_Position; %һλãlastGenX_Position   NP*Dim
        lastGenX_Velocity = X_Velocity; %һٶȣlastGenX_Velocity   NP*Dim
        
       %% ´浵AeAp
        for i = 1:NP
            Ae = [Ae;X_Position(i,:)]; %  Xi  Ae ϲΪһ¼
            AeFitness(i) = TestFunction(index,Ae(i,:));  % 浵AeдŵӵӦֵ
            Ir(i) = (lastGenFitnessX(i) - fitnessX(i))./exp(sqrt(sum((lastGenX_Position(i,:) - X_Position(i,:)).^2))); % ÿӵIr
        end
        [sortAeFitness,sortIndexAe]=sort(AeFitness);
        Ae = Ae(sortIndexAe(1:M),:);  % 浵AežӢ
        AeFitness = AeFitness(sortIndexAe(1:M));
        [sortIr,sortIndexIR] = sort(Ir,'descend');
        Ap = X_Position(sortIndexIR(1:M),:); % 浵Apż
        NFEs = NFEs + NP;
              
        p_k(1:M) = (M-(1:M)+1)./sum(1:M); % 浵AeApиŵMӱѡĸĸ
        
        for i = 1:NP
           %% ģ
            % AeѡһΪĸ֮һ
            tempP = 0;
            randNum = rand;
            for k = 1:M
               if(tempP <= randNum && randNum <= tempP + p_k(k))
                   X_p1 = Ae(k,:);
                   break;
               end
               tempP = p_k(k) + tempP;
            end
            % ApѡһΪĸ֮һ
            tempP = 0;
            randNum = rand;
            for k = 1:M
               if(tempP <= randNum && randNum <= tempP + p_k(k))
                   X_p2 = Ap(k,:);
                   break;
               end
               tempP = p_k(k) + tempP;
            end
            
            for j = 1:Dim
                 % 
                if(rand < p_c)
                    E_Position(i,j) = X_p1(:,j);
                else
                    E_Position(i,j) = X_p2(:,j);
                end

                % 
                if(rand < p_m)
                    E_Position(i,j) = LB(:,j) + rand*(UB(:,j)-LB(:,j));
                end
            end
           
           %% ѡѧϰģ
            fitnessE(i) = TestFunction(index,E_Position(i,:));
            NFEs = NFEs + 1;
            if(fitnessE(i) < GBest_fitness)
               X_Velocity(i,:) = w*X_Velocity(i,:) + rand.*(E_Position(i,:) - X_Position(i,:));
               GBest_fitness = fitnessE(i);
               GBest_pos = E_Position(i,:);
            elseif(fitnessE(i) < PBest_fitness(i))
               X_Velocity(i,:) = w*X_Velocity(i,:) + rand.*(E_Position(i,:) - X_Position(i,:)) + rand.*(GBest_pos-X_Position(i,:));
            else
               X_Velocity(i,:) = w*X_Velocity(i,:) + rand.*(PBest_pos(i,:) - X_Position(i,:));
            end
            % ӵٶȱ߽
            for d = 1:Dim
              if(X_Velocity(i,d)>Vmax(i,d) || X_Velocity(i,d)<Vmin(i,d)) 
                  X_Velocity(i,d) = Vmin(i,d) + rand*(Vmax(i,d)-Vmin(i,d));
              end
           end
            X_Position(i,:) = X_Position(i,:) + X_Velocity(i,:);  
            % ӵλñ߽
            for d = 1:Dim
                if(X_Position(i,d)>UB(d) || X_Position(i,d)<LB(d)) 
                  X_Position(i,d) = LB(d) + rand*(UB(d)-LB(d));
                end
            end
            
           %% ´浵Ao
            if(sizeAo<NP && fitnessE(i)<PBest_fitness(i))
                Ao = [Ao;E_Position(i,:)];
                sizeAo = sizeAo + 1;
                AoFitness(sizeAo) = fitnessE(i);
            elseif(sizeAo>=NP && fitnessE(i)<PBest_fitness(i))
                randNum = randperm(sizeAo,2);
                if(TestFunction(index,Ao(randNum(1),:))<TestFunction(index,Ao(randNum(2),:)))
                    Ao(randNum(2),:) = E_Position(i,:);
                    AoFitness(randNum(2)) = fitnessE(i);
                else
                    Ao(randNum(1),:) = E_Position(i,:);
                    AoFitness(randNum(1)) = fitnessE(i);
                end
            end
            
           %% ۵ Xi , PBest
            if(TestFunction(index,X_Position(i,:)) < PBest_fitness(i))
               PBest_fitness(i) =  TestFunction(index,X_Position(i,:));
               PBest_pos(i,:) = X_Position(i,:);
            end
            NFEs = NFEs + 1;
        end
        
       %% ô浵 Ao ԹӸ
        sizeAo = size(Ao,1);
        [sortPBestFitness,PBestIndex] = sort(PBest_fitness,'descend');
        randNum = randperm(sizeAo,sizeAo);
        gro_Position = Ao(randNum(1:sizeAo),:);
        gro_fitness = AoFitness(randNum(1:sizeAo));
        for i=1:2:sizeAo-1          
            if(gro_fitness(i)<gro_fitness(i+1))
               E_Pos = gro_Position(i,:);
               E_Fitness = gro_fitness(i);
            else
               E_Pos = gro_Position(i+1,:);
               E_Fitness = gro_fitness(i+1);
            end
            if(E_Fitness < sortPBestFitness(i))
                PBest_pos(i,:) = E_Pos;
                PBest_fitness(i) = E_Fitness;
            end
        end
        
       %% GBest
        [GBest_fitness,GBest_index] = min(PBest_fitness);
        GBest_pos = PBest_pos(GBest_index,:);
    end

    %% ս
    endNFEs=NFEs;
    optValue=GBest_fitness;
    bestP=GBest_pos;
    

end
    
